# sb16_csp is added conditionally!
%define MODULES_NOCSPCTL ac3dec as10k1 echomixer envy24control hdspconf hdsploader hdspmixer ld10k1 mixartloader pcxhrloader rmedigicontrol seq/sbiload sscape_ctl us428control usx2yloader vxloader
# qlo10k1 needs l10k1 and thus this package will only bootstrap if it's installed first

%ifarch ppc %mips %arm
%define MODULES %{MODULES_NOCSPCTL}
%else
%define MODULES %{MODULES_NOCSPCTL} sb16_csp
%endif

%define tool_fver 1.0.25
%define tool_beta 0
%define ld10k1_major 0

%define ld10k1_name lo10k1
%define ld10k1_libname_orig lib%ld10k1_name
%define ld10k1_libname %mklibname %ld10k1_name %ld10k1_major

%if %tool_beta
%define fname %name-%tool_fver%tool_beta
%else
%define fname %name-%tool_fver
%endif

Name:		alsa-tools
Version:	%tool_fver
%if %tool_beta
Release: %mkrel 0.%{tool_beta}.2
%else
Release:	%mkrel 1
%endif
Summary:	Advanced Linux Sound Architecture (ALSA) tools
License:	GPLv2+
URL:		http://alsa-project.org
Source0:	ftp://ftp.alsa-project.org/pub/tools/%fname.tar.bz2
Source1:	90-alsa-tools-firmware.rules
Patch1:		alsa-tools-1.0.18-sscape_ctl.c.patch
# From Debian: adapt to udev instead of hotplug - AdamW 2008/03
Patch2:		alsa-tools-1.0.16-usx2yloader-udev.patch
# (tv) fix underlinking:
Patch3:		alsa-tools-1.0.17rc1-fix-link.patch
# (hk) fix build errors with -Wformat -Werror=format-security
Patch4:		alsa-tools-1.0.19-format-security.patch
Group:		Sound
BuildRequires:	libalsa-devel >= %version
BuildRequires:	fltk-devel
BuildRequires:	gtk2-devel
BuildRequires:	ncurses-devel
BuildRequires:	automake
BuildRequires:	desktop-file-utils

Obsoletes:	ac3dec envy24control hdspconf hdspmixer rmedigicontrol sb16_csp
Provides:	ac3dec envy24control hdspconf hdspmixer rmedigicontrol sb16_csp

Obsoletes:	sbiload sscape_ctl us428control as10k1 echomixer
Provides:	sbiload sscape_ctl us428control as10k1 echomixer

%description
Advanced Linux Sound Architecture (ALSA) utils. Modularized 
architecture with support for a large range of ISA and PCI cards.
Fully compatible with OSS/Lite (kernel sound drivers), but 
contains many enhanced features.

This source rpm package provides several sub packages:
* ac3dec - A free AC-3 stream decoder
* as10k1 - AS10k1 Assembler version A0.99
* cspctl - Sound Blaster 16 ASP/CSP control program
* envy24control - Control tool for Envy24 (ice1712) based soundcards
* hdspmixer - Mixer for the RME Hammerfall DSP cards
* rmedigicontrol - Control panel for RME Hammerfall cards
* sbiload - An OPL2/3 FM instrument loader for ALSA sequencer
* sscape_ctl - ALSA SoundScape control utility
* us428control - Control tool for Tascam 428

%package	firmware
Summary:	ALSA tools for uploading firmware to some soundcards
License:	GPL
Group:		Sound
Requires:	alsa-firmware >= %{version}
Obsoletes:	hdsploader mixartloader pcxhrloader usx2yloader vxloader
Provides:	hdsploader mixartloader pcxhrloader usx2yloader vxloader

%description	firmware
This package contains tools for flashing firmware into certain sound cards.
The following tools are available:

* hdsploader   - for RME Hammerfall DSP cards
* mixartloader - for Digigram miXart soundcards
* pcxhrloader  - for Digigram PCXHR soundcards
* usx2yloader  - second phase firmware loader for Tascam USX2Y USB soundcards
* vxloader     - for Digigram VX soundcards

%package -n	ld10k1
Summary:	AS10k1 Assembler version A0.99
License:	GPL
Group:		Sound

%description -n	ld10k1
This is patch loader for EMU10K1 (EMU10K2) for ALSA.
This disables AC3 passthrough on SB Live.

There are two parts:
Server - ld10k1 - running as service - it is storing driver state - it must run
        under root or by setuided
Client - lo10k1 - controls server
and dump loader dl10k1 - loads dumps previously created with lo10k1 & ld10k1.

ld10k1 will clear card DSP program and you will hear nothing.
You must load some patches to route sound from inputs to outputs (use
audigy_init script for audigy 1, 2 or init_live for sb live).
After loading patch check and set oss mixer emulation through proc file
(/proc/asound/card/oss_mixer)

In directory setup are some patches which I use on my Audigy for testing.
With this you will have exactly same mixer as with original driver (+headphone
control, not tested AudigyDrive inputs and outputs, AC3 passthrought).
Use as10k1 compiler from alsa-tools package to compile patches.

%package -n %ld10k1_libname
Summary:	Ld10k1_ library
Group:		Sound
Provides:	%ld10k1_libname_orig = %version
Obsoletes:	%ld10k1_libname_orig
Conflicts:	ld10k1 < 1.0.12

%description -n %ld10k1_libname
This is the library of ld10k1.

%package -n %{ld10k1_libname}-devel
Summary:    Development files for l10k1
Group:      Development/C
Requires:   %{ld10k1_libname} = %version
Provides:   %{ld10k1_libname_orig}-devel = %version-%release
Obsoletes:  %{ld10k1_libname_orig}-devel

%description -n %{ld10k1_libname}-devel
This package contains files needed in order to develop an application
that made use of the ld10k1 library.

%prep
%setup -q -n %fname
%patch1
%patch2 -p1 -b .usx2yudev
%patch3 -p1 -b .link
%patch4 -p1 -b .format-security
pushd envy24control
touch NEWS ChangeLog
popd

%build
for i in %{MODULES}; do
pushd ${i}
# (tv) force it not to lookup aclocal-1.9 & co
libtoolize -c -f
autoreconf
%configure2_5x
%make
popd
done

%install
rm -rf %{buildroot}

for i in %{MODULES}; do
pushd ${i}
  %makeinstall_std
popd
done

# install some extra stuff for ac3dec
install -m755 ac3dec/test/dither_test %{buildroot}%{_bindir}/dither_test
install -m755 ac3dec/test/imdct_test %{buildroot}%{_bindir}/imdct_test

# install menu entries


mkdir -p %{buildroot}%{_datadir}/applications
cat > %{buildroot}%{_datadir}/applications/mageia-echomixer.desktop << EOF
[Desktop Entry]
Name=Echo mixer
Comment=Control tool for Echoaudio soundcards
Exec=%{_bindir}/echomixer
Icon=sound_section
Terminal=false
Type=Application
Categories=AudioVideo;Audio;Mixer;
EOF


mkdir -p %{buildroot}%{_datadir}/applications
cat > %{buildroot}%{_datadir}/applications/mageia-envy24control.desktop << EOF
[Desktop Entry]
Name=Envy24control
Comment=Control tool for Envy24 (ice1712) based soundcards
Exec=%{_bindir}/envy24control
Icon=sound_section
Terminal=false
Type=Application
Categories=AudioVideo;Audio;Mixer;
EOF



mkdir -p %{buildroot}%{_datadir}/applications
cat > %{buildroot}%{_datadir}/applications/mageia-rmedigicontrol.desktop << EOF
[Desktop Entry]
Name=RME Digicontrol
Comment=Control panel for RME Hammerfall
Exec=%{_bindir}/rmedigicontrol
Icon=sound_section
Terminal=false
Type=Application
Categories=AudioVideo;Audio;Mixer;
EOF

# fix .desktop files
sed -i 's,.png,,' %{buildroot}%{_datadir}/applications/{hdspconf,hdspmixer}.desktop

desktop-file-install \
	--vendor="" \
	--remove-key="Encoding" \
	--remove-key="FilePattern" \
	--remove-category="Application" \
	--dir=%{buildroot}%{_datadir}/applications/ %{buildroot}%{_datadir}/applications/*


# udev rules file for usx2yloader - AdamW 2008/03
mkdir -p %{buildroot}%{_sysconfdir}/udev/rules.d
install -D -m644 %{SOURCE1} %{buildroot}%{_sysconfdir}/udev/rules.d/

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc ac3dec/COPYING ac3dec/README ac3dec/TODO
%doc as10k1/README as10k1/COPYING as10k1/examples
%doc echomixer/AUTHORS echomixer/COPYING echomixer/README
%doc envy24control/AUTHORS envy24control/COPYING envy24control/README
%doc hdspconf/COPYING hdspconf/README
%doc hdspmixer/AUTHORS hdspmixer/COPYING hdspmixer/README
%doc rmedigicontrol/COPYING rmedigicontrol/README
%doc seq/sbiload/COPYING seq/sbiload/README
%{_bindir}/ac3dec
%{_bindir}/as10k1
%{_bindir}/dither_test
%{_bindir}/echomixer
%{_bindir}/envy24control
%{_bindir}/extract_ac3
%{_bindir}/hdspconf
%{_bindir}/hdspmixer
%{_bindir}/imdct_test
%{_bindir}/rmedigicontrol
%{_bindir}/sbiload
%{_bindir}/sscape_ctl
%{_bindir}/us428control
%_datadir/applications/hdspmixer.desktop
%{_datadir}/applications/hdspconf.desktop
%{_datadir}/applications/mageia-echomixer.desktop
%{_datadir}/applications/mageia-envy24control.desktop
%_datadir/applications/mageia-rmedigicontrol.desktop
%{_datadir}/sounds/opl3/
%{_mandir}/man1/envy24control.1*
%{_datadir}/pixmaps/hdspconf.png
%_datadir/pixmaps/hdspmixer.png

%ifnarch ppc %mips %arm
%doc sb16_csp/COPYING sb16_csp/README
%_bindir/cspctl
%_mandir/man1/cspctl.*
%endif

%files firmware
%defattr(-,root,root)
%doc hdsploader/AUTHORS hdsploader/COPYING hdsploader/README
%doc usx2yloader/README
%doc vxloader/README
%{_sysconfdir}/udev/rules.d/90-alsa-tools-firmware.rules
/lib/udev/tascam_fpga
/lib/udev/tascam_fw
%{_bindir}/hdsploader
%{_bindir}/mixartloader
%{_bindir}/pcxhrloader
%{_bindir}/usx2yloader
%{_bindir}/vxloader

%files -n	ld10k1
%defattr(-,root,root)
%doc as10k1/README as10k1/COPYING as10k1/examples
%_bindir/lo10k1
%_bindir/init_audigy
%_bindir/init_audigy_eq10
%_bindir/init_live
%_datadir/ld10k1
%_sbindir/ld10k1
%_sbindir/dl10k1
%_sbindir/ld10k1d

%files -n %ld10k1_libname
%defattr(-, root, root)
%_libdir/lib%{ld10k1_name}.so.*

%files -n %{ld10k1_libname}-devel
%defattr(-,root,root)
%_includedir/lo10k1
%_datadir/aclocal/ld10k1.m4
%_libdir/lib%{ld10k1_name}.so
%_libdir/lib%{ld10k1_name}.la


%changelog

* Wed Jan 25 2012 colin <colin> 1.0.25-1.mga2
+ Revision: 201525
- New version: 1.0.25
- Dropped gtk fix that no longer applies and doesn't seem needed.

* Mon Jul 11 2011 fwang <fwang> 1.0.24.1-4.mga2
+ Revision: 122090
- rebuild for new fltk

* Fri Mar 11 2011 ahmad <ahmad> 1.0.24.1-3.mga1
+ Revision: 68253
- obsolete and provide echomixer

* Thu Mar 10 2011 ahmad <ahmad> 1.0.24.1-2.mga1
+ Revision: 67270
- use 90-alsa-tools-firmware.rules (from Fedora), it has the new udev rules
  syntax, and we can easily sync it from Fedora if the syntax changes again

* Tue Mar 08 2011 ahmad <ahmad> 1.0.24.1-1.mga1
+ Revision: 66355
- adapt the main package description to the firmware split
- update to 1.0.24.1
- split the firmware in a separate src.rpm (alsa-firmware)
- add the appropriate obsoletes and provides to accomodate the split
- put loaders in a new subpackage alsa-tools-firmware
- merge all the subpackages in the main package (the packages are very small,
  all in all they're ~1.2MB)
- leave ld10k1 in a separate sub-package as it has a lib and devel packages
- fix the lincese

* Sun Jan 09 2011 ahmad <ahmad> 1.0.23-3.mga1
+ Revision: 1640
- rename .desktop files to mageia
- clean spec of old distros macros
- imported package alsa-tools


* Mon Jan 03 2011 Oden Eriksson <oeriksson@mandriva.com> 1.0.23-3mdv2011.0
+ Revision: 627712
- don't force the usage of automake1.7

* Mon Nov 29 2010 Oden Eriksson <oeriksson@mandriva.com> 1.0.23-2mdv2011.0
+ Revision: 603175
- rebuild

* Sat Apr 17 2010 Colin Guthrie <cguthrie@mandriva.org> 1.0.23-1mdv2010.1
+ Revision: 535805
- New version: 1.0.23

* Mon Jan 18 2010 Jérôme Brenier <incubusss@mandriva.org> 1.0.22-2mdv2010.1
+ Revision: 493170
- rebuild for new fltk

* Mon Dec 21 2009 Colin Guthrie <cguthrie@mandriva.org> 1.0.22-1mdv2010.1
+ Revision: 480507
- New version: 1.0.22

* Fri Sep 25 2009 Olivier Blin <oblin@mandriva.com> 1.0.21-4mdv2010.0
+ Revision: 448769
- disable sb16_csp on MIPS and ARM (from Arnaud Patard)

* Mon Aug 31 2009 Thierry Vignaud <tv@mandriva.org> 1.0.21-3mdv2010.0
+ Revision: 422979
- new release

* Mon May 11 2009 Thierry Vignaud <tv@mandriva.org> 1.0.20-3mdv2010.0
+ Revision: 374787
- new release

* Thu Apr 23 2009 Thierry Vignaud <tv@mandriva.org> 1.0.19-2mdv2009.1
+ Revision: 368901
- rebuild for missing firmwares on 32bits

* Sat Mar 21 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 1.0.19-1mdv2009.1
+ Revision: 359681
- Fixed alsa-tools 1.0.19 build errors in current cooker.

  + Thierry Vignaud <tv@mandriva.org>
    - new version (we really should split firmware out...)

* Sun Dec 14 2008 Funda Wang <fwang@mandriva.org> 1.0.18-3mdv2009.1
+ Revision: 314114
- rediff patch0

* Wed Nov 12 2008 Thierry Vignaud <tv@mandriva.org> 1.0.18-2mdv2009.1
+ Revision: 302464
- patch 2: rediff
- new tools version (we really should split firmware out...)

* Wed Jul 16 2008 Colin Guthrie <cguthrie@mandriva.org> 1.0.17-1mdv2009.0
+ Revision: 236497
- New version: 1.0.17

* Mon Jun 16 2008 Thierry Vignaud <tv@mandriva.org> 1.0.17-0.rc2.2mdv2009.0
+ Revision: 219557
- new release

  + Pixel <pixel@mandriva.com>
    - rpm filetriggers deprecates update_menus/update_scrollkeeper/update_mime_database/update_icon_cache/update_desktop_database/post_install_gconf_schemas

* Tue Jun 10 2008 Thierry Vignaud <tv@mandriva.org> 1.0.17-0.rc1.1mdv2009.0
+ Revision: 217380
- patch 3: fix underlinking
- new release

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Thu Mar 27 2008 Thierry Vignaud <tv@mandriva.org> 1.0.16-3mdv2008.1
+ Revision: 190693
- make sb16_csp obsoletes/provides cspctl (#39408)

* Mon Mar 10 2008 Adam Williamson <awilliamson@mandriva.org> 1.0.16-2mdv2008.1
+ Revision: 183652
- create udev rules file for usx2yloader in %%install
- correct menu categories
- usx2yloader requires fxload
- add usx2yloader-udev.patch from Debian: fixes usx2yloader to use udev not hotplug

* Wed Feb 06 2008 Thierry Vignaud <tv@mandriva.org> 1.0.16-1mdv2008.1
+ Revision: 163084
- new release

* Tue Jan 22 2008 Thierry Vignaud <tv@mandriva.org> 1.0.16-0.rc1.2mdv2008.1
+ Revision: 155984
- new release
- drop old menu
- kill re-definition of %%buildroot on Pixel's request

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

* Tue Oct 16 2007 Thierry Vignaud <tv@mandriva.org> 1.0.15-2mdv2008.1
+ Revision: 99107
- fix build
- new release
- fix summary-ended-with-dot

* Thu Jun 07 2007 Anssi Hannula <anssi@mandriva.org> 1.0.14-2mdv2008.0
+ Revision: 36130
- rebuild with correct optflags

  + Thierry Vignaud <tv@mandriva.org>
    - new release

* Thu May 03 2007 Thierry Vignaud <tv@mandriva.org> 1.0.14-0.rc4.2mdv2008.0
+ Revision: 21575
- new release


* Thu Mar 08 2007 Thierry Vignaud <tvignaud@mandriva.com> 1.0.14-0.rc3.1mdv2007.1
+ Revision: 138564
- new release

* Fri Dec 22 2006 Christiaan Welvaart <cjw@daneel.dyndns.org> 1.0.13-2mdv2007.1
+ Revision: 101486
- disable sb16_csp for ppc (again)

* Wed Oct 25 2006 Thierry Vignaud <tvignaud@mandriva.com> 1.0.13-1mdv2007.0
+ Revision: 72291
- fix build (add new firmware for EMU1010
- Import alsa-tools

* Tue Oct 24 2006 Thierry Vignaud <tvignaud@mandriva.com> 1.0.13-1mdv2007.1
- new release

* Fri Sep 15 2006 Thierry Vignaud <tvignaud@mandriva.com> 1.0.12-2mdv2007.0
- fix update (fcrozat)

* Fri Aug 25 2006 Thierry Vignaud <tvignaud@mandriva.com> 1.0.12-1mdv2007.0
- new release

* Sat Aug 05 2006 Thierry Vignaud <tvignaud@mandriva.com> 1.0.12-0.rc2.1mdv2007.0
- new release
- fix typo in package name

* Tue Jul 25 2006 Thierry Vignaud <tvignaud@mandriva.com> 1.0.12-0.rc1.1mdv2007.0
- new release
- switch to XDG menus

* Fri May 05 2006 Thierry Vignaud <tvignaud@mandriva.com> 1.0.11-3mdk
- patch 1: fix m4 macro when building with gtk+2-devel and w/o gtk+-devel

* Thu May 04 2006 Thierry Vignaud <tvignaud@mandriva.com> 1.0.11-2mdk
- kill obsolete comment
- drop gtk-devel buildrequire (everything is now linked with gtk+-2)

* Thu May 04 2006 Thierry Vignaud <tvignaud@mandriva.com> 1.0.11-1mdk
- new release
- drop patch 2 (merged upstream)
- drop patch 3 (better fix upstream)

* Wed Nov 16 2005 Thierry Vignaud <tvignaud@mandriva.com> 1.0.10-1mdk
- new release
- a few rpmlint fixes

* Fri Nov 04 2005 Thierry Vignaud <tvignaud@mandriva.com> 1.0.10-0.rc2.1mdk
- new release

* Tue Oct 04 2005 Olivier Blin <oblin@mandriva.com> 1.0.9-2mdk
- move to new /lib/firmware directory

* Sat May 28 2005 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.0.9-1mdk
- new release

* Tue May 24 2005 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.0.9-0.rc4.2mdk
- add hdspconf, ld10k1 & sb16_csp subpackages

* Tue May 24 2005 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.0.9-0.rc4.1mdk
- new release

* Tue May 10 2005 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.0.9-0.rc3.1mdk
- new release
- drop now uneeded patch 5
- patch 3: fix compiling with gcc-4.0

* Sat Apr 16 2005 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.0.9rc2-0.rc2.1mdk
- new release

* Thu Jan 13 2005 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.0.8-1mdk
- new release

* Tue Jan 11 2005 Guillaume Rousse <guillomovitch@mandrake.org> 1.0.8-0.rc2.2mdk
- fix lib64 build

* Wed Jan 05 2005 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.0.8-0.rc2.1mdk
- new release

* Thu Dec 30 2004 Christiaan Welvaart <cjw@daneel.dyndns.org> 1.0.8-0.rc1.2mdk
- if the module list is generated somehow, why is it in the specfile?

* Wed Dec 22 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.0.8-0.rc1.1mdk
- new release

* Fri Nov 19 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.0.7-1mdk
- new release

* Tue Aug 17 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.0.6-1mdk
- new release
- replace SOURCE 2 bu patch 2 so that we do not lost usefull checks in the
  future

* Thu Aug 05 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.0.6-0.rc1.1mdk
- new release

* Sun Jun 13 2004 Christiaan Welvaart <cjw@daneel.dyndns.org> 1.0.5-2mdk
- fix build with gcc 3.4
- add BuildRequires: automake1.7
- do not build cspctl on ppc

* Sat May 29 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.0.5-1mdk
- new release

* Tue Apr 06 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.0.4-1mdk
- new release

* Fri Apr 02 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.0.4-0.rc1_1mdk
- new release

